<?php
namespace FluidTYPO3\Flux\Backend;
/***************************************************************
 *  Copyright notice
 *
 *  (c) 2014 Claus Due <claus@namelesscoder.net>
 *
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 *****************************************************************/

use FluidTYPO3\Flux\Core;
use TYPO3\CMS\Core\TypoScript\TemplateService;
use TYPO3\CMS\Core\Utility\GeneralUtility;

/**
 * @package Flux
 * @subpackage Backend
 */
class TypoScriptTemplate {

	/**
	 * Includes static template from extensions
	 *
	 * @param array $params
	 * @param TemplateService $pObj
	 * @return void
	 */
	public function preprocessIncludeStaticTypoScriptSources(array &$params, TemplateService $pObj) {
		unset($pObj);
		if (TRUE === isset($params['row']['root']) && TRUE === (boolean) $params['row']['root']) {
			$existingTemplates = GeneralUtility::trimExplode(',', $params['row']['include_static_file']);
			$globalStaticTemplates = Core::getStaticTypoScript();
			$staticTemplates = array_merge($globalStaticTemplates, $existingTemplates);
			$params['row']['include_static_file'] = implode(',', array_unique($staticTemplates));
		}
	}

}
